import java.util.Random;

// Represents the internal state of a game of 2048 and allows various
// operations of game moves as methods. Uses TwoNTiles and DenseBoard
// to implement the game.
public class Game2048{
  // Random number generator used in the provided methods
  // getRandomTile() and randomFreeLocation()
  private Random random;

  // ADD ADDITOINAL FIELDS HERE

  // Generate and return a random tile according to the probability
  // distribution. 
  //    70% 2-tile
  //    25% 4-tile
  //     5% 8-tile
  // Use the internal random number generator for the game.
  public Tile getRandomTile(){
    double rand = this.random.nextDouble();
    //    System.out.printf("\n\nMY DOUBLE IS %f\n",rand);
    if(rand <= 0.70){
      return new TwoNTile(2);
    }
    else if(rand <= 0.95){
      return new TwoNTile(4);
    }
    else{
      return  new TwoNTile(8);
    }
  }

  // If the game board has F>0 free spaces, return a random integer
  // between 0 and F-1.  If there are no free spaces, throw an
  // exception.
  public int randomFreeLocation(){
    int freeSpaces = this.board.getFreeSpaceCount();
    return this.random.nextInt(freeSpaces);
  }

  // ADDITIONAL METHODS HERE
}

